#include <bits/stdc++.h>
using namespace std;

const long long MX=7e5+10;

vector < pair < int , long long > > ms[2*MX];
long long mas[2*MX];

void fun()
{
    int n;
    cin>>n;

    for(int i=0;i<=2*n;i++)
    {
        mas[i]=0;
        ms[i].clear();
    }

    for(long long i=1;i<=n;i++)
    {
        long long a,b,c;
        cin>>a>>b>>c;

        if(a>b)
        {
            swap(a,b);
        }

        ms[a].push_back({b,c});
        ms[b].push_back({a,c});

        mas[a]+=c;
        mas[b]+=c;
    }

    long long mx=0;
    for(int i=1;i<=2*n;i++)
    {
        mx=max(mx,mas[i]);
    }

    for(int i=1;i<=2*n;i++)
    {
        if(ms[i].size()==2)
        {
            for(auto u:ms[ms[i][0].first])
            {
                if(u.first==ms[i][1].first)
                {
                    mx=max(mx,ms[i][0].first+ms[i][1].first+u.second);
                }
            }
        }
    }

    cout<<mx<<"\n";
}

int main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    long long t;
    cin>>t;

    while(t--)
    {
        fun();
    }

    return 0;
}